// Configurator.h
// Configuration messages for the visualizers.
// A. Savidis, slightly modified of first version from Y. Lilis.
// September, 2005.
// Project: FLIP Suite (Execution visualizer, Savidis, 2005).
//

#ifdef	HAS_VISUALIZER

#ifndef CONFIGURATOR_H
#define CONFIGURATOR_H

class Configurator {

	public:

	static char* OnBlockEnter;
	static char* OnBlockExit;

	static char* OnIfEnter;
	static char* OnIfExit;

	static char* OnForEnter;
	static char* OnForExit;

	static char* OnConditionValue;

	static char* OnWhileEnter;
	static char* OnWhileExit;

	static char* OnBreak;
	static char* OnContinue;

	static char* OnCaseBegin;
	static char* OnCaseEnd;

	static char* OnArithmeticOperatorUsage;
	static char* OnRelationalOperatorUsage;
	static char* OnUnaryOperatorUsage;

	static char* OnVarWrite;
	static char* OnVarDeclaration;
	static char* OnVarDestruction;

	static char* OnArrayDeclaration;
	static char* OnArrayAllocation;
	static char* OnArrayDestruction;
	static char* OnArrayIndexing;

	static char* OnRecordDeclaration;
	static char* OnRecordDestruction;

	static char* OnFunctionEnter;
	static char* OnFunctionExit;

	static char* OnResult;
	static char* OnFinish;

	static char* OnPageOf;
	static char* OnRowOf;
	static char* OnContentOf;
	static char* OnPositionOf;

	static char* OnRegionUsage;
	static char* OnRegionIndexing;

	static char* OnFunctionUsage;

	static char* OnGrantPositions;
	static char* OnReleasePositions;
};

#endif	// Header file end point.

#endif	// HAS_VISUALIZER
