// Configurator.cpp
// Visualisation string messages.
// A. Savidis, slightly modified of first version from Y. Lilis
// (excluded configuration too).
// September, 2005.
// Project: FLIP Execution Visualizer, Savidis, 2005.
//

#ifdef	HAS_VISUALIZER

#include "Configurator.h"

char* Configurator::OnBlockEnter = "Entering block at line %d";
char* Configurator::OnBlockExit = "Exiting from block at line %d";

char* Configurator::OnIfEnter = "Entering if at line %d";
char* Configurator::OnIfExit = "Exiting from if at line %d";

char* Configurator::OnForEnter = "Entering for at line %d";
char* Configurator::OnForExit = "Exiting from for at line %d";

char* Configurator::OnBreak = "Breaking current loop from line %d";
char* Configurator::OnContinue = "Continuing current loop from line %d";

char* Configurator::OnWhileEnter = "Entering while at line %d";
char* Configurator::OnWhileExit = "Exiting from while at line %d";

char* Configurator::OnCaseBegin = "Entering case at line %d";
char* Configurator::OnCaseEnd = "Exiting from case at line %d";

char* Configurator::OnConditionValue = "%s";

char* Configurator::OnArithmeticOperatorUsage = "Arithmetic operator (%d, %d) '%s' (%d, %d)";
char* Configurator::OnRelationalOperatorUsage = "Relational operator (%d, %d) '%s' (%d, %d)";
char* Configurator::OnUnaryOperatorUsage = "Unary operator '%s' (%d, %d)";

char* Configurator::OnVarWrite = "Writing variable - notebook position (%d, %d)\n";
char* Configurator::OnVarDeclaration = "Declaring variable - notebook position (%d, %d)\n";
char* Configurator::OnVarDestruction = "Destroying variable - notebook position (%d, %d)\n";

char* Configurator::OnArrayDeclaration = "Array declaration done, starting from (%d, %d), size %d";
char* Configurator::OnArrayAllocation = "Array variable declaration, allocating memory, size %d";
char* Configurator::OnArrayDestruction = "Array destruction begins, starting from (%d, %d), size %d";
char* Configurator::OnArrayIndexing = "Array indexing, starting from (%d, %d), size %d, index %d";

char* Configurator::OnRecordDeclaration = "Record variable declaration, allocating memory";
char* Configurator::OnRecordDestruction = "Record variable destruction, freeing memory";

char* Configurator::OnFunctionEnter = "Enter function '%s' at line %d";
char* Configurator::OnFunctionExit = "Exit function '%s' at line %d";

char* Configurator::OnResult = "Return '%s', function '%s' at line %d";
char* Configurator::OnFinish = "Return, function '%s' at line %d";

char* Configurator::OnPageOf = "Getting page number of variable (%d, %d) at line %d";
char* Configurator::OnRowOf = "Getting row number of variable (%d, %d) at line %d";
char* Configurator::OnContentOf = "Getting content of variable (%d, %d) at line %d";
char* Configurator::OnPositionOf = "Getting position of variable (%d, %d) at line %d";

char* Configurator::OnRegionUsage = "Requesting region (%d, %d to %d)";
char* Configurator::OnRegionIndexing = "Indexing region (%d, %d to %d), index %d";

char* Configurator::OnFunctionUsage = "Using %s library function '%s' at line %d";

char* Configurator::OnGrantPositions = "Granting positions, starting from (%d, %d), size %d, at line %d";
char* Configurator::OnReleasePositions = "Releasing positions, starting from (%d, %d), at line %d";

#endif	// HAS_VISUALIZER
