#ifdef	EXERCISE1

#include "servant.h"

//////////////////////////////////////////////////////

PROCEDURE ShowMenu ARGUMENTS ()
BEGIN
	OUTPUT("1. Decimal to binary.");
	OUTPUT("2. Binary to decimal.");
	OUTPUT("3. Exit.");
	OUTPUTEX("Option:");
END

//////////////////////////////////////////////////////

PROCEDURE DecimalToBinary ARGUMENTS ()
BEGIN
	INTEGER				number;
	ARRAY(BOOLEAN,32)	bits;
	INTEGER				i, n = 0;

	FOR	i=0; i < 32; i = i+1 DO
		bits[i] = FALSE;

	OUTPUTEX("Number:");
	INPUTEX(number);

	IF	number >= 0	THEN
	BEGIN
		WHILE number > 0 DO
		BEGIN
			bits[n] = (number % 2) DIFFERENT 0;
			number = number / 2;
			n = n+1;
		END
		FOR	i = n-1; i >= 0; i = i-1 DO
			IF bits[i] EQUAL TRUE THEN
				OUTPUTEX("1");
			ELSE
				OUTPUTEX("0");
		OUTPUT(LINE);
	END
	ELSE
		OUTPUT("Negative number!");
END

FUNCTION(INTEGER) BinStrToDec ARGUMENTS (STRING bits) 
BEGIN
	INTEGER i, number  = 0;
	FOR	i = 0; i < string_length(bits) AND i < 32; i = i+1 DO
		BEGIN
			CHARACTER c = string_get(bits, i);
			number = number * 2;
			IF  c EQUAL '1' THEN
				number = number + 1;
			ELSE
			IF c DIFFERENT '0' THEN
			BEGIN
				OUTPUT("Non binary digit found!");
				RESULT(0);
			END
		END
	RESULT(number);
END

PROCEDURE BinaryToDecimal ARGUMENTS ()
BEGIN
	STRING		bits;
	INTEGER		number = 0, i;

	OUTPUTEX("Bits:");
	INPUTEX(bits);
	OUTPUT(BinStrToDec(bits));
END

//////////////////////////////////////////////////////

PROGRAM_BEGIN
	BOOLEAN	done;
	WHILE NOT done	DO
	BEGIN
		INTEGER option;
		ShowMenu();
		INPUTEX(option);
		IF option < 0 OR option > 3 THEN
			OUTPUT("Option not in [1..3]!");
		ELSE
		IF	option EQUAL 1 THEN
			DecimalToBinary();
		ELSE
		IF	option	EQUAL 2 THEN
			BinaryToDecimal();
		ELSE
			done = TRUE;
	END
PROGRAM_END

#endif