#ifdef	EXERCISE2

#include "servant.h"

//////////////////////////////////////////////////////

FUNCTION(REAL) Operation ARGUMENTS (REAL x, CHARACTER op, REAL y)
BEGIN
	IF	op EQUAL '+' THEN
		RESULT(x+y);
	ELSE
	IF	op EQUAL '-' THEN
		RESULT(x-y);
	ELSE
	IF	op EQUAL '*' THEN
		RESULT(x*y);
	ELSE
	IF	op EQUAL '/' THEN
	BEGIN
		IF x EQUAL 0 THEN
		BEGIN
			OUTPUTEX("Divide by 0!");
			OUTPUTEX(LINE);
			STOP;
		END
		RESULT(x/y);
	END
END

float Operation (float x, char op, float y) {
  if (op == '+')
	return x+y;
  else
  if (op == '-')
	return x-y;
  else
  if (op == '*')
	return x*y;
  else
  if (op == '/')
     if (x == 0)
         return 0; 
     else 
         return x/y;
}

//////////////////////////////////////////////////////

FUNCTION(REAL) GetNumber ARGUMENTS()
BEGIN
	REAL x;
	OUTPUTEX(">");
	INPUTEX(x);
	RESULT(x);
END

//////////////////////////////////////////////////////

FUNCTION(CHARACTER) GetOperation ARGUMENTS()
BEGIN
	CHARACTER c;
	OUTPUTEX("?");
	INPUTEX(c);

	IF	c DIFFERENT '+' AND
		c DIFFERENT '*' AND
		c DIFFERENT '/' AND
		c DIFFERENT '-' AND
		c DIFFERENT '=' THEN
		BEGIN
			OUTPUTEX("Wrong operator!");
			OUTPUTEX(LINE);
			STOP;
		END
	RESULT(c);
END

//////////////////////////////////////////////////////

PROGRAM_BEGIN
	BOOLEAN		done = FALSE;
	REAL		x = 0, result = 0;
	CHARACTER	op = '#';
	INTEGER		n = 0;

	WHILE NOT done	DO
	BEGIN
		x = GetNumber();
		IF op EQUAL '#' THEN
			result = x;
		ELSE
			result = Operation(result, op, x);

		op = GetOperation();

		IF	op EQUAL '=' THEN
		BEGIN
			OUTPUTEX("Result="); 
			OUTPUTEX(result); 
			OUTPUTEX(LINE);

			OUTPUTEX("Total operations:");
			OUTPUTEX(n);
			OUTPUTEX(LINE);

			done = TRUE;
		END
		ELSE
			n = n + 1;
	END
PROGRAM_END

//////////////////////////////////////////////////////

#endif

